#include <util.h>
#include <sstream>
#include <iostream>
#include <fstream>
#include <algorithm>


using namespace std;


bool isEmpty(std::string str)
{

    replaceString(str, " ", "");
    if ( str.empty() )
        return true;
    else
        return false;

} 


double stringToDouble( const std::string& s )
{
    std::istringstream i(s);
    double x;
    if (!(i >> x))
        return 0;
    return x;
} 


bool checkDouble( const std::string& s )
{
    std::istringstream i(s);
    double x;
    if (!(i >> x))
        return false;
    return true;
} 


bool stripeInfo(string &line, string tag)
{

    auto titlePos = line.find(tag);
    auto titleFound = false;

    if (titlePos != std::string::npos) {
        //cout << "TAG " << tag << " FOUND!!!!" << endl;
        titleFound = false;
        auto const pos = line.find_last_of(':');
        line = line.substr(pos+1);

        return true;
    }

    return false;

}


void replaceString(std::string & str, const std::string& from, const std::string& to)
{
    size_t start_pos = 0;

    while((start_pos = str.find(from, start_pos)) != std::string::npos) {
        str.replace(start_pos, from.length(), to);
        start_pos += to.length(); // Handles case where 'to' is a substring of 'from'
    }

}


bool anotherWayToSort(Component & i, Component & j) { return i.name().size() > j.name().size(); }


std::vector<Component> sortComponent(const std::vector<Component *> stringVec)
{

    std::vector <Component> cVec(stringVec.size());

    for (auto i=0; i<stringVec.size(); i++) {
        cVec[i].index(i);
        cVec[i].name(stringVec[i]->name());
        cVec[i].min(stringVec[i]->min());
        cVec[i].max(stringVec[i]->max());
    }
    
    // Sorting the string vector
    std::sort(cVec.begin(), cVec.end(), anotherWayToSort);

	return cVec;
}


void replacePattern(const std::vector<Component *> stringVec, std::string & eq)
{

    //string eq("x * xot + yv - 2 * y * xy + xy");
    //vector<string> stringVec = {"x", "xot", "y", "xy", "xya", "yv", "yxt", "xyt"};

    std::vector <Component> cVec = sortComponent(stringVec);

    for (auto i=0; i<cVec.size(); i++) {
        stringstream ss;
		ss << cVec[i].index() + 1;
        replaceString(eq, cVec[i].name(), "$"+ss.str());
    }

}

